\documentclass{report}
  
\usepackage{common/uruwi}

\title{x801tr04 Architecture}
\author{uruwi}

\begin{document}

\pagecolor{Rhodamine!15}

\maketitle

\trsummary

\section{Introduction}

This report delves into the extended details of the architecture outlined in tr02. At the same time, tr04 assumes that one has read tr02.

\chapter{List of programs that must be written}

The following programs must be written (with SLOC estimates):

\begin{enumerate}
  \item A gatekeeper server that handles logins and redirects clients to shards (5,000 SLOC).
  \item A database server that receives and sends abstract (DBMS-independent) messages and translates them to and from its native convention (20,000 SLOC).
  \item A shard server that simulates the game and communicates with the client (100,000 SLOC).
  \item A client program that can log into servers, download assets, accept input from the player and display output (100,000 SLOC).
  \item Some tools to convert asset sources into a compiled format that can be used by the client and server (20,000 SLOC).
  \item A filehost, but a generic web server can act as one.
  \item Some glue scripts to launch server processes in an appropriate manner (2,000 SLOC).
\end{enumerate}

\chapter{Interaction dialogue}

\section{Joining a server}

\begin{longtabu}[c]{llY}
  \hline
  Sender & Recipient & Dialogue \\
  \hline
  \endhead
  \hline
  \endfoot

  \multicolumn{3}{c}{The client wishes to connect to the server.} \\
  \hline
  C & G & I would like to log in as \emph{Uruwi} and my password is \emph{hunter2}. \\
  G & D & Is there a user with username \emph{Uruwi} and password \emph{hunter2}? \\
  D & G & Yes, their user ID is \emph{1}. \\
  G & S & Please reserve space for player \emph{\#1} from \emph{some IP address}. \\
  S & G & I have reserved space for player \emph{\#1} from \emph{some IP address}. Give them a cookie \emph{32FF...}. \\
  G & C & Login succeeded; the filehost is at \emph{\url{https://example.com/x801-assets/}}. Please go to the shard at \emph{\url{https://example.com:6944}} with the cookie \emph{32FF...}. \\
  \hline
  \multicolumn{3}{c}{The client updates its files.} \\
  \hline
  C & F & Please give me the manifest. \\
  F & C & (manifest) \\
  C & F & I do not have the file \emph{images/kitten.png}; please give it to me. \\
  F & C & (kitten.png) \\
  C & F & My copy of \emph{images/puppy.png} is out of date; please give me a newer copy. \\
  F & C & (puppy.png) \\
  \hline
  \multicolumn{3}{c}{The client connects to the shard.} \\
  \hline
  C & S & I would like to connect with the cookie \emph{32FF...}. \\
  S & D & Does User \emph{\#1} have a player character? \\
  D & S & No, User \emph{\#1} does not have a player character. \\
  S & C & Success; I have a space held for you. You do not have a player character; please create one. \\
  C & S & I would like to create a player named \emph{Cheryl FrogBane} of the \emph{Ice} school. \\
  S & D & Please create a player character for \emph{\#1} named \emph{Cheryl FrogBane} of the \emph{Ice} school. \\
  D & S & Created a player character for \emph{\#1}. \\
  S & C & Success. \\
  S & C & You are now at \emph{the Commons} at \emph{(69, -44)}. \\
  S & C & Players near you are \emph{Player \#1 at (69, -44)} and \emph{Player \#2 at (68, -50)}. \\
  C & S & Who are players \emph{\#1} and \emph{\#2}? \\
  S & C & Player \emph{\#1} is \emph{Cheryl FrogBane (Uruwi)} and Player \emph{\#2} is \emph{Luis LifeHaven (luis999)}. \\
  \hline
  \multicolumn{3}{c}{The client disconnects.} \\
  \hline
  C & S & I would like to disconnect. \\
  S & C & You have been disconnected. \\
\end{longtabu}

\section{Movement and interaction}

\begin{longtabu}[c]{llY}
  \hline
  Sender & Recipient & Dialogue \\
  \hline
  \endhead
  \hline
  \endfoot
  
  \multicolumn{3}{c}{The player moves.} \\
  \hline
  S & C & Players near you are \emph{Player \#1 at (69, -44)} and \emph{Player \#2 at (68, -50)}. \\
  C & S & I would like to move left. \\
  S & C & Players near you are \emph{Player \#1 at (68, -44)} and \emph{Player \#2 at (68, -51)}. \\
  \hline
  \multicolumn{3}{c}{The player sends and receives messages.} \\
  \hline
  C & S & I would like to send a message \emph{Hi!} \\
  S & C & Message successfully sent. \\
  S & C & Player \emph{\#2} sent a message \emph{hi, uruwi} \\
  C & S & I would like to send a message \emph{I'm going to the shopping district} \\
  \hline
  \multicolumn{3}{c}{The player goes to another area.} \\
  \hline
  C & S & I would like to move left. \\
  S & C & Players near you are \emph{Player \#1 at (67, -44)} and \emph{Player \#2 at (67, -51)}. \\
  \multicolumn{3}{c}{\&c.} \\
  S & C & You are now at \emph{the Shopping District} at \emph{(120, 240)}. \\
  S & C & Players near you are \emph{Player \#1 at (120, -240)}. \\
  S & C & Players near you are \emph{Player \#1 at (120, -240)} and \emph{Player \#2 at (120, -240)}. \\
  \hline
  \multicolumn{3}{c}{The player uses a teleport button.} \\
  \hline
  C & S & I would like to use the teleport button. \\
  S & C & Done. \\
  S & C & You are now at \emph{the Commons} at \emph{(69, -44)}. \\
  C & S & I would like to use the teleport button. \\
  S & C & You can use the teleport button again in \emph{59} seconds. \\
\end{longtabu}

\end{document}
